import Dexie from "dexie";

export interface ICell {
  p: object,
  s: number,
  v: string | number | boolean,
  m: string,
  f: string,
  fm: object,
  h: string,
  n: string
}

export interface IJson {
  j: object[]
}

export class AppDatabase extends Dexie {
  cells: Dexie.Table<ICell, number>;
  jsons: Dexie.Table<IJson, number>;

  public constructor() {
    super('database');
    this.version(2).stores({
      cells: '++id, p, s, v, m, f, fm, h, n',
      jsons: '++id, j',
    });
  }
}
