import { AppDatabase, ICell, IJson } from "./data";

export class WriterJson {
  static mockJson(count: number): IJson {
    const mock: IJson = { j: [] };
    for (let i = 0; i < count; i++) {
      mock.j.push({
        p: {}, s: 0, v: '', m: '', f: '', fm: {}, h: '', n: '',
      });
    }
    return mock;
  }

  static async writeJson(json: IJson): Promise<void> {
    const database = new AppDatabase();
    await database.jsons.add(json);
  }

  static async write1w(): Promise<void> {
    console.time("写入1W数据耗时: ");
    await WriterJson.writeJson(WriterJson.mockJson(10000));
    console.timeEnd("写入1W数据耗时: ");
  }

  static async write5w(): Promise<void> {
    console.time("写入5W数据耗时: ");
    await WriterJson.writeJson(WriterJson.mockJson(50000));
    console.timeEnd("写入5W数据耗时: ");
  }

  static async write10w(): Promise<void> {
    console.time("写入10W数据耗时: ");
    await WriterJson.writeJson(WriterJson.mockJson(100000));
    console.timeEnd("写入10W数据耗时: ");
  }

  static async write50w(): Promise<void> {
    console.time("写入50W数据耗时: ");
    await WriterJson.writeJson(WriterJson.mockJson(500000));
    console.timeEnd("写入50W数据耗时: ");
  }

  static async write100w(): Promise<void> {
    console.time("写入100W数据耗时: ");
    await WriterJson.writeJson(WriterJson.mockJson(1000000));
    console.timeEnd("写入100W数据耗时: ");
  }

  static async write500w(): Promise<void> {
    console.time("写入500W数据耗时: ");
    await WriterJson.writeJson(WriterJson.mockJson(5000000));
    console.timeEnd("写入500W数据耗时: ");
  }

  static async write1000w(): Promise<void> {
    console.time("写入1000W数据耗时: ");
    await WriterJson.writeJson(WriterJson.mockJson(10000000));
    console.timeEnd("写入1000W数据耗时: ");
  }
}

export class WriterArray {
  static mockArray(count: number): ICell[] {
    const cells = [];
    for (let i = 0; i < count; i++) {
      cells.push({
        p: {}, s: 0, v: '', m: '', f: '', fm: {}, h: '', n: '',
      });
    }
    return cells;
  }

  static async writeArray(cells: ICell[]): Promise<void> {
    const database = new AppDatabase();
    await database.cells.bulkAdd(cells);
  }

  static async write1w(): Promise<void> {
    console.time("写入1W数据耗时: ");
    await WriterArray.writeArray(WriterArray.mockArray(10000));
    console.timeEnd("写入1W数据耗时: ");
  }

  static async write5w(): Promise<void> {
    console.time("写入5W数据耗时: ");
    await WriterArray.writeArray(WriterArray.mockArray(50000));
    console.timeEnd("写入5W数据耗时: ");
  }

  static async write10w(): Promise<void> {
    console.time("写入10W数据耗时: ");
    await WriterArray.writeArray(WriterArray.mockArray(100000));
    console.timeEnd("写入10W数据耗时: ");
  }

  static async write50w(): Promise<void> {
    console.time("写入50W数据耗时: ");
    await WriterArray.writeArray(WriterArray.mockArray(500000));
    console.timeEnd("写入50W数据耗时: ");
  }

  static async write100w(): Promise<void> {
    console.time("写入100W数据耗时: ");
    await WriterArray.writeArray(WriterArray.mockArray(1000000));
    console.timeEnd("写入100W数据耗时: ");
  }

  static async write500w(): Promise<void> {
    console.time("写入500W数据耗时: ");
    await WriterArray.writeArray(WriterArray.mockArray(5000000));
    console.timeEnd("写入500W数据耗时: ");
  }

  static async write1000w(): Promise<void> {
    console.time("写入1000W数据耗时: ");
    await WriterArray.writeArray(WriterArray.mockArray(10000000));
    console.timeEnd("写入1000W数据耗时: ");
  }
}
